



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spring集成redis——主从配置以及哨兵监控</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spring集成redis——主从配置以及哨兵监控</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 13:10:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>Redis主从模式配置：</strong></p>
<p>Redis的主从模式配置是非常简单的，首先我们需要有2个可运行的redis环境：</p>
<p>master node : 192.168.56.101 8887</p>
<p>slave node: &nbsp; &nbsp; 192.168.56.102 7777</p>
<p>我们只要在slave 节点的配置文件中，找到&nbsp;slaveof开头</p>
<p>然后修改为：（master的ip与端口）</p>
<div>
<pre class="prettyprint linenums">slaveof 192.168.56.101  </pre>
</div>
<p>这样就可以了，下面我们来验证一下，首先启用master和slave的redis服务，然后登录redis-cli，输入info</p>
<p>然后看下192.168.56.101：8887的信息，红色的地方，表示当前节点为master节点，有几个从节点和从节点的信息</p>
<div>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">192.168.56.101:8887&gt; info</pre>
<pre class="prettyprint linenums"># Replication<br />
role:master<br />
connected_slaves:1<br />
slave0:ip=192.168.56.102,port=7777,state=online,offset=568,lag=1<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:</pre>
</div>
<p>在看192.168.56.102：7777的信息</p>
<div>
<pre class="prettyprint linenums"></pre>
<pre class="prettyprint linenums">192.168.56.102:7777&gt; info</pre>
<pre class="prettyprint linenums"># Replication<br />
role:slave<br />
master_host:192.168.56.101<br />
master_port:8887<br />
master_link_status:up<br />
master_last_io_seconds_ago:10<br />
master_sync_in_progress:0<br />
slave_repl_offset:<br />
slave_priority:<br />
slave_read_only:<br />
connected_slaves:<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:</pre>
</div>
<p>在master，创建一个key-value：</p>
<div>
<pre class="prettyprint linenums">192.168.56.101:&gt; set aa aa<br />
OK</pre>
</div>
<p>在slave节点</p>
<div>
<pre class="prettyprint linenums">192.168.56.102:&gt; get aa<br />
"aa"</pre>
</div>
<p>因为默认的设置从节点是不能写只能读的，所以如果要在从节点写东西是报错的，如下：</p>
<div>
<pre class="prettyprint linenums">192.168.56.102:&gt; set aa 2a<br />
(error) READONLY You can't write against a read only slave.</pre>
</div>
<p>这样一来主从模式就好了，如果要有多个从节点，只要改变他们的slaveof的配置就行了。</p>
<p>当然如果只这样配置，在生产上面是没有多大用处的，因为如果无论master节点还是slave节点挂了，我们都要手动启动来让他继续恢复工作，那么能不能让他自动恢复呢？比如master挂掉了，在slave节点中选一个节点自动更换成master。根据这个需求，redis在2.4之后出现了sentinel，其目的就是监控主从节点的健壮性，然后自动选举master节点下面就来看看如何配置sentinel。</p>
<p><strong>Redis 的 Sentinel配置</strong></p>
<h3>一、Sentinel介绍</h3>
<p>Sentinel是Redis的高可用性（HA）解决方案，由一个或多个Sentinel实例组成的Sentinel系统可以监视任意多个主服务器，以及这些主服务器属下的所有从服务器，并在被监视的主服务器进行下线状态时，自动将下线主服务器属下的某个从服务器升级为新的主服务器，然后由新的主服务器代替已下线的主服务器继续处理命令请求。Redis提供的sentinel（哨兵）机制，通过sentinel模式启动redis后，自动监控master/slave的运行状态，基本原理是：心跳机制+投票裁决</p>
<ul><li>监控（Monitoring）： Sentinel 会不断地检查你的主服务器和从服务器是否运作正常。</li>
<li>提醒（Notification）： 当被监控的某个 Redis 服务器出现问题时， Sentinel 可以通过 API 向管理员或者其他应用程序发送通知。</li>
<li>自动故障迁移（Automatic failover）： 当一个主服务器不能正常工作时， Sentinel 会开始一次自动故障迁移操作， 它会将失效主服务器的其中一个从服务器升级为新的主服务器， 并让失效主服务器的其他从服务器改为复制新的主服务器； 当客户端试图连接失效的主服务器时， 集群也会向客户端返回新主服务器的地址， 使得集群可以使用新主服务器代替失效服务器</li></ul>
<h3>二、Sentinel的主从原理</h3>
<p><img referrerpolicy="no-referrer"src="http://i.imgur.com/IxlXAg2.png" />&nbsp;<img referrerpolicy="no-referrer"src="http://i.imgur.com/G80prp9.png" /></p>
<p><img referrerpolicy="no-referrer"src="http://i.imgur.com/yVJJtb4.png" />&nbsp;<img referrerpolicy="no-referrer"src="http://i.imgur.com/AlBo86Q.png" /></p>
<h3>三、Redis Sentinel配置</h3>
<p>这里采用了一个master 一个slave 一个sentinel</p>
<p>master 的redis.conf配置，找到下面的并修改：</p>
<div>
<pre class="prettyprint linenums">port<br />
bind 192.168.56.101</pre>
</div>
<p>slave 的redis.conf配置，找到下面的并修改，如果master节点设置了密码，下面红色部分要加上</p>
<div>
<pre class="prettyprint linenums">port<br />
bind 192.168.56.102<br />
slaveof 192.168.56.101 8887<br />masterauth master的密码</pre>
</div>
<p>sentinel的sentinel.conf 配置</p>
<div>
<pre class="prettyprint linenums">port<br />
protected-mode yes<br />
bind 192.168.56.101<br />
dir /tmp<br />
sentinel monitor mymaster 192.168.56.101<br />
sentinel down-after-milliseconds mymaster<br />
sentinel parallel-syncs mymaster<br />
sentinel failover-timeout mymaster </pre>
</div>
<p>tips:</p>
<p>如果停掉master 后，sentinel 显示足够数量的 sdown 后，没有出现odown或try-failover，则检查密码等配置是否正确</p>
<p>如果停掉master后，试图切换的时候出现 failover-abort-not-elected</p>
<div>
<pre class="prettyprint linenums">1）如果redis实例没有配置<br />
protected-mode yes<br />
bind 192.168.56.101<br />
则在sentinel 配置文件加上<br />
protected-mode no<br />
2）如果redis实例有配置<br />
protected-mode yes<br />
bind 192.168.56.101<br />
则在sentinel 配置文件加上<br />
protected-mode yes<br />
bind 192.168.56.101</pre>
</div>
<p>上面的配置都弄好之后，分别启动master、slave、sentinel(前面2个是redis-service 启动，后面是redis-sentinel)服务，然后我们可以redis-cli查看对于的info信息（跟上面主从操作是一样的）</p>
<p>master节点</p>
<div>
<pre class="prettyprint linenums">[root@localhost ]# ./redis-cli -h 192.168.56.101 -p<br />
192.168.56.101:&gt; info<br />
&hellip;&hellip;<br />
# Replication<br />
role:master<br />
connected_slaves:<br />
slave0:ip=192.168.56.102,port=,state=online,offset=,lag=<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:<br />
&hellip;&hellip;</pre>
</div>
<p>slave节点</p>
<div>
<pre class="prettyprint linenums">[root@localhost ]# ./redis-cli -h 192.168.56.102 -p<br />
192.168.56.102:&gt; info<br />
&hellip;&hellip;<br />
# Replication<br />
role:slave<br />
master_host:192.168.56.101<br />
master_port:<br />
master_link_status:up<br />
master_last_io_seconds_ago:<br />
master_sync_in_progress:<br />
slave_repl_offset:<br />
slave_priority:<br />
slave_read_only:<br />
connected_slaves:<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:<br />
&hellip;&hellip;</pre>
</div>
<p>sentinel节点信息</p>
<div>
<pre class="prettyprint linenums">[root@localhost ]# ./redis-cli -h 192.168.56.101 -p<br />
192.168.56.101:&gt; info<br />
&hellip;&hellip;<br />
# Sentinel<br />
sentinel_masters:<br />
sentinel_tilt:<br />
sentinel_running_scripts:<br />
sentinel_scripts_queue_length:<br />
sentinel_simulate_failure_flags:<br />
master0:name=mymaster,status=ok,address=192.168.56.101:,slaves=,sentinels=<br />
&hellip;&hellip;</pre>
</div>
<p>下面我们把master节点给干掉，</p>
<div>
<pre class="prettyprint linenums">192.168.56.101:&gt; SHUTDOWN<br />
not connected&gt; </pre>
</div>
<p>这个时候，在sentinel界面会输出下面的信息：</p>
<div>
<pre class="prettyprint linenums">:X  Jun ::27.313 # +sdown master mymaster 192.168.56.101<br />
:X  Jun ::27.313 # +odown master mymaster 192.168.56.101  #quorum /<br />
:X  Jun ::27.313 # +new-epoch<br />
:X  Jun ::27.313 # +try-failover master mymaster 192.168.56.101<br />
:X  Jun ::27.317 # +vote-for-leader 9354edabc95f19b3d99991f0877d0e66ada04e5b<br />
:X  Jun ::27.317 # +elected-leader master mymaster 192.168.56.101<br />
:X  Jun ::27.317 # +failover-state-select-slave master mymaster 192.168.56.101<br />
:X  Jun ::27.384 # +selected-slave slave 192.168.56.102: 192.168.56.102  @ mymaster 192.168.56.101<br />
:X  Jun ::27.384 * +failover-state-send-slaveof-noone slave 192.168.56.102: 192.168.56.102  @ mymaster 192.168.56.101<br />
:X  Jun ::27.450 * +failover-state-wait-promotion slave 192.168.56.102: 192.168.56.102  @ mymaster 192.168.56.101<br />
:X  Jun ::28.255 # +promoted-slave slave 192.168.56.102: 192.168.56.102  @ mymaster 192.168.56.101<br />
:X  Jun ::28.255 # +failover-state-reconf-slaves master mymaster 192.168.56.101<br />
:X  Jun ::28.317 # +failover-end master mymaster 192.168.56.101<br />
:X  Jun ::28.317 # +switch-master mymaster 192.168.56.101  192.168.56.102<br />
:X  Jun ::28.318 * +slave slave 192.168.56.101: 192.168.56.101  @ mymaster 192.168.56.102 </pre>
</div>
<p>现在我们在查看以前的slave节点：</p>
<div>
<pre class="prettyprint linenums">192.168.56.102:&gt; info<br />
&hellip;&hellip;<br />
# Replication<br />
role:master<br />
connected_slaves:<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:<br />
&hellip;&hellip;</pre>
</div>
<p>这个时候以前的slave变成了master，所以现在没有从节点了，所以&nbsp;connected_slaves:0 ，下面我们把干掉的192.168.56.101 8887服务给启用，然后在查看现在的master，</p>
<div>
<pre class="prettyprint linenums">192.168.56.102:&gt; info<br />
&hellip;&hellip;<br />
# Replication<br />
role:master<br />
connected_slaves:<br />
slave0:ip=192.168.56.101,port=,state=online,offset=,lag=<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:<br />
&hellip;&hellip;</pre>
</div>
<p>这个时候可以看到，多出了一个slave，即以前的master变成了从节点，我们再看以前的master节点信息：</p>
<div>
<pre class="prettyprint linenums">192.168.56.101:&gt; info<br />
&hellip;&hellip;<br />
# Replication<br />
role:slave<br />
master_host:192.168.56.102<br />
master_port:<br />
master_link_status:up<br />
master_last_io_seconds_ago:<br />
master_sync_in_progress:<br />
slave_repl_offset:<br />
slave_priority:<br />
slave_read_only:<br />
connected_slaves:<br />
master_repl_offset:<br />
repl_backlog_active:<br />
repl_backlog_size:<br />
repl_backlog_first_byte_offset:<br />
repl_backlog_histlen:<br />
&hellip;&hellip;</pre>
</div>
<p>上面就是sentinel自动的对redis的主从切换的配置，以及信息的变化，下面来看在Spring中如何配置。</p>
<h3>四、Spring中 Sentinel配置</h3>
<p>pom.xml文件中添加依赖包</p>
<div>
<pre class="prettyprint linenums">  &lt;!--redis 支持java的语言 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;redis.clients&lt;/groupId&gt;<br />
            &lt;artifactId&gt;jedis&lt;/artifactId&gt;<br />
            &lt;version&gt;2.9.0&lt;/version&gt;<br />
        &lt;/dependency&gt;

&lt;!-- spring data redis --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework.data&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-data-redis&lt;/artifactId&gt;<br />
            &lt;version&gt;1.8.1.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;</pre>
</div>
<p>spring-redis.xml的配置：</p>
<div>
<pre class="prettyprint linenums"> &lt;!--redis哨兵 --&gt;<br />
     &lt;bean id="redisSentinelConfiguration"<br />
           class="org.springframework.data.redis.connection.RedisSentinelConfiguration"&gt;<br />
         &lt;property name="master"&gt;<br />
             &lt;bean class="org.springframework.data.redis.connection.RedisNode"&gt;<br />
                 &lt;property name="name" value="mymaster"/&gt;<br />
             &lt;/bean&gt;<br />
         &lt;/property&gt;<br />
         &lt;property name="sentinels"&gt;<br />
             &lt;set&gt;<br />
                 &lt;bean class="org.springframework.data.redis.connection.RedisNode"&gt;<br />
                     &lt;constructor-arg name="host" value="192.168.56.101"/&gt;<br />
                     &lt;constructor-arg name="port" value="9999"/&gt;<br />
                 &lt;/bean&gt;<br />
             &lt;/set&gt;<br />
         &lt;/property&gt;<br />
     &lt;/bean&gt;

     &lt;bean id="jedisConnFactory"<br />
           class="org.springframework.data.redis.connection.jedis.JedisConnectionFactory"&gt;<br />
         &lt;!--&lt;property name="hostName" value="${redis.host}"/&gt;--&gt;<br />
         &lt;!--&lt;property name="port" value="${redis.port}"/&gt;--&gt;<br />
         &lt;!--&lt;property name="password" value="${redis.password}"/&gt;--&gt;<br />
         &lt;!--&lt;property name="usePool" value="false"/&gt;--&gt;<br />
         &lt;!--&lt;property name="poolConfig" ref="poolConfig"/&gt;--&gt;<br />
         &lt;constructor-arg name="sentinelConfig" ref="redisSentinelConfiguration"/&gt;<br />
     &lt;/bean&gt;

     &lt;bean id="stringRedisTemplate" class="org.springframework.data.redis.core.StringRedisTemplate"&gt;<br />
         &lt;property name="connectionFactory" ref="jedisConnFactory"/&gt;<br />
     &lt;/bean&gt;</pre>
</div>
<p>tips:</p>
<p>第25行如果我们不配poolConfig的话，也不要把第24行的usePool改成false，如果把usePool改成false，那么上面的哨兵配置好像就无效了。</p>
<h3>Sentinel模式下的几个事件</h3>
<ul><li>+reset-master ：主服务器已被重置。</li>
<li>+slave ：一个新的从服务器已经被 Sentinel 识别并关联。</li>
<li>+failover-state-reconf-slaves ：故障转移状态切换到了 reconf-slaves 状态。</li>
<li>+failover-detected ：另一个 Sentinel 开始了一次故障转移操作，或者一个从服务器转换成了主服务器。</li>
<li>+slave-reconf-sent ：领头（leader）的 Sentinel 向实例发送了 [SLAVEOF](/commands/slaveof.html) 命令，为实例设置新的主服务器。</li>
<li>+slave-reconf-inprog ：实例正在将自己设置为指定主服务器的从服务器，但相应的同步过程仍未完成。</li>
<li>+slave-reconf-done ：从服务器已经成功完成对新主服务器的同步。</li>
<li>-dup-sentinel ：对给定主服务器进行监视的一个或多个 Sentinel 已经因为重复出现而被移除 &mdash;&mdash; 当 Sentinel 实例重启的时候，就会出现这种情况。</li>
<li>+sentinel ：一个监视给定主服务器的新 Sentinel 已经被识别并添加。</li>
<li>+sdown ：给定的实例现在处于主观下线状态。</li>
<li>-sdown ：给定的实例已经不再处于主观下线状态。</li>
<li>+odown ：给定的实例现在处于客观下线状态。</li>
<li>-odown ：给定的实例已经不再处于客观下线状态。</li>
<li>+new-epoch ：当前的纪元（epoch）已经被更新。</li>
<li>+try-failover ：一个新的故障迁移操作正在执行中，等待被大多数 Sentinel 选中（waiting to be elected by the majority）。</li>
<li>+elected-leader ：赢得指定纪元的选举，可以进行故障迁移操作了。</li>
<li>+failover-state-select-slave ：故障转移操作现在处于 select-slave 状态 &mdash;&mdash; Sentinel 正在寻找可以升级为主服务器的从服务器。</li>
<li>no-good-slave ：Sentinel 操作未能找到适合进行升级的从服务器。Sentinel 会在一段时间之后再次尝试寻找合适的从服务器来进行升级，又或者直接放弃执行故障转移操作。</li>
<li>selected-slave ：Sentinel 顺利找到适合进行升级的从服务器。</li>
<li>failover-state-send-slaveof-noone ：Sentinel 正在将指定的从服务器升级为主服务器，等待升级功能完成。</li>
<li>failover-end-for-timeout ：故障转移因为超时而中止，不过最终所有从服务器都会开始复制新的主服务器（slaves will eventually be configured to replicate with the new master anyway）。</li>
<li>failover-end ：故障转移操作顺利完成。所有从服务器都开始复制新的主服务器了。</li>
<li>+switch-master ：配置变更，主服务器的 IP 和地址已经改变。 这是绝大多数外部用户都关心的信息。</li>
<li>+tilt ：进入 tilt 模式。</li>
<li>-tilt ：退出 tilt 模式。</li></ul>
<p>以上就是redis的主从及哨兵的配置，如果有错，谢谢指出。</p>
<p>参考：<a href="http://wosyingjun.iteye.com/blog/2289593" rel="external nofollow noreferrer">http://wosyingjun.iteye.com/blog/2289593</a></p>
<p>　　　<a href="http://www.cnblogs.com/yjmyzz/p/redis-sentinel-sample.html" rel="external nofollow noreferrer">http://www.cnblogs.com/yjmyzz/p/redis-sentinel-sample.html</a></p>
<p><a href="http://blog.csdn.net/yypzye/article/details/52281282" rel="external nofollow noreferrer">http://blog.csdn.net/yypzye/article/details/52281282</a></p>
<p>本实项目下载：<a href="https://github.com/eoooxy/anhoo" rel="external nofollow noreferrer">https://github.com/eoooxy/anhoo</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k7xj9j.html">form表单的字符串进行utf-8编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zr2znq.html">World  Wind  &period;NET源码编译问题处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93127r8.html">VS2013 密钥</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykzlj9.html">Python&mdash;&mdash;目录操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qye6zx9.html">DataTable &period;Load 方法 &lpar;IDataReader&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vjvko8.html">《摇滚南京》&mdash;&mdash;&amp;quot&semi;人生下来就是孤独&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xjoee8.html">记一次linux samba服务问题调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1lx4k9.html">Python判断上传文件类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vmnz9.html">JavaScript&hellip;&hellip;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zgd109.html">7篇Model View和4篇双缓冲</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dozgq.html">gradle学习系列之eclipse中简单构建android项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzp0r9.html">【NOIP2012-开车旅行】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpv7l0q.html">Android Studio科普篇&mdash;&mdash;2&period;误区</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7xjz8.html">css，解决文字与图片对齐的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me315rq.html">Netty初体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/960pnvn9.html">Linux驱动之USB总线驱动程序框架简析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rk1d58.html">python3 第二十九章 - 内置函数之tuple相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o136nxq.html">RDO快速部署OpenStack</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13eolq.html">【maven】之nexus常用的一些配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvrpkg8.html">Go语言包管理工具dep</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93pdl0r8.html">51nod 1051 最大子矩阵和</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1n0ox9.html">OpenVirteX 创建简易虚拟网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl5yo39.html">Ubuntu 14&period;04 安装 qemu</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnyl04q.html">【Coursera】Security Introduction -Ninth Week&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmn7g49.html">&lbrack;POJ1958&rsqb;&lbrack;Strange Tower of Hanoi&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/902j56nq.html">HDU 3549 Flow Problem（最大流模板）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn2z0xq.html">【Python】【环境搭建】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppkr3k9.html">MongoDB（课时28 group操作）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv4kxdq.html">django路由转发</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp4o1z9.html">mysql 超大数据&sol;表管理技巧</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
